
#include <assert.h>

int find(int n, const int a[], int v)
{
  int i;

  for (i=0; i <n; i++) {
    if (a[i] == v) {
      return i;
    }
  }

  return -1;
}

int invalid_find(int n, int a[], int v)
{
  if (n > 0) {
    a[0] = v;
    return 0;
  } else
    return -1;
}

/*@ requires 0 < n && \valid(a+(0..n-1));
 */
int invalid_find2(int n, const int a[], int v)
{
  if (n > 0) {
    a[0] = v;
    return 0;
  } else
    return -1;
}

int main(void)
{
  int a[5] = { 9, 7, 8, 9, 6 };

  int const f1 = find(5, a, 8);
  assert(f1 == 2);

  int const f2 = find(5, a, 15);
  assert(f2 == -1);

  return 0;
}
